
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef speett_TCLSERV_CLIENT_ERROR_H
#define speett_TCLSERV_CLIENT_ERROR_H

#include <server/speettError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum speett_error {
	E_speett_OK					  			= 0,

	/* module errors */
	E_speett_SYNTAX_ERROR                   = S_speett_SYNTAX_ERROR,
	E_speett_NO_SENTENCE                    = S_speett_NO_SENTENCE,
	E_speett_NO_SOUND                       = S_speett_NO_SOUND,
	E_speett_NO_MEMORY                      = S_speett_NO_MEMORY,
	E_speett_NO_AUDIO_DEVICE                = S_speett_NO_AUDIO_DEVICE,
	E_speett_NO_SUCH_FILE                   = S_speett_NO_SUCH_FILE,


	/* std errors */
	E_speett_ACTIVITY_INTERRUPTED           = S_speett_stdGenoM_ACTIVITY_INTERRUPTED,
	E_speett_TOO_MANY_ACTIVITIES            = S_speett_stdGenoM_TOO_MANY_ACTIVITIES,
	E_speett_ACTIVITY_FAILED                = S_speett_stdGenoM_ACTIVITY_FAILED,
	E_speett_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_speett_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_speett_UNKNOWN_ACTIVITY               = S_speett_stdGenoM_UNKNOWN_ACTIVITY,
	E_speett_FORBIDDEN_ACTIVITY_TRANSITION  = S_speett_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_speett_SYSTEM_ERROR                   = S_speett_stdGenoM_SYSTEM_ERROR,
	E_speett_ACTIVITY_ALREADY_ENDED         = S_speett_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_speett_WAIT_INIT_RQST                 = S_speett_stdGenoM_WAIT_INIT_RQST,
	E_speett_CONTROL_CODEL_ERROR            = S_speett_stdGenoM_CONTROL_CODEL_ERROR,
	E_speett_EXEC_TASK_SUSPENDED            = S_speett_stdGenoM_EXEC_TASK_SUSPENDED,
	E_speett_BAD_BLOCK_TYPE                 = S_speett_stdGenoM_BAD_BLOCK_TYPE,
	E_speett_BAD_POSTER_TYPE                = S_speett_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum speett_error speett_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int speett_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the speett context.
 *
 * Returns NULL in case of failure
 */
const char* speett_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
